<template>
  <div class="app">
    <div v-if="isLoading">Loading ......</div>
    <div v-else>
      <div class="container">
        <div class="left-container">
          <table>
            <thead>
              <tr>
                <th>Прізвище</th>
                <th>Ім'я</th>
                <th>Кімната</th>
                <th>Блок</th>
                <th>Номер телефону</th>
                <th>Дата і час</th>
                <th>Дії</th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="item in getItemsList" :key="item.id">
                <td>{{ item.lastName }}</td>
                <td>{{ item.name }}</td>
                <td>{{ item.room }}</td>
                <td>{{ item.block }}</td>
                <td>{{ item.number }}</td>
                <td>{{ item.problem }}</td>
                <td>{{ item.data }}</td>
                <td>
                  <button @click="deleteItem(item.id)">Виконано</button>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
        <div class="right-container">
          <div class="search-container">
            <hr />
            <label for="filterData">Фільтрувати за номером пралки : </label>
            <select v-model="selectedNumber" id="filterNumber">
              <option value="">Всі</option>
              <option
                v-for="number in uniqueNumbers"
                :key="number"
                :value="number"
              >
                {{ number }}
              </option>
            </select>
          </div>
          <hr />
          <div class="student-form">
            <div>
              <label for="lastName">Прізвище</label>
              <input v-model="pralkaLs.lastName" type="text" id="lastName" />
            </div>
            <div>
              <label for="name">Ім'я</label>
              <input v-model="pralkaLs.name" type="text" id="name" />
            </div>
            <div>
              <label for="room">Кімната</label>
              <input v-model="pralkaLs.room" type="text" id="room" />
            </div>
            <div>
              <label for="block">Блок</label>
              <input v-model="pralkaLs.block" type="text" id="block" />
            </div>
            <div>
              <label for="number">Номер пралки</label>
              <input v-model="pralkaLs.number" type="text" id="number" />
            </div>
            <div>
              <label for="problem">Опишіть поломку</label>
              <input v-model="pralkaLs.problem" type="text" id="problem" />
            </div>
            <div>
              <label for="data">Дата і час</label>
              <input v-model="pralkaLs.data" type="text" id="data" />
            </div>
            <button @click="addItem(pralkaLs)">Додати студента</button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters, mapActions } from "vuex";

export default {
  name: "PListView",
  data() {
    return {
      pralkaLs: {},
      selectedNumber: " ",
    };
  },
  computed: {
    ...mapGetters("pralkaLs", ["getItemsList", "isLoading"]),
    uniqueNumbers() {
      return [...new Set(this.getItemsList.map((item) => item.number))];
    },
    filteredItems() {
      return this.selectedNumber
        ? this.getItemsList.filter(
            (item) => item.number === this.selectedNumber
          )
        : this.getItemsList;
    },
  },
  created() {
    this.loadList();
  },
  methods: {
    ...mapActions("pralkaLs", [
      "loadList",
      "addItem",
      "deleteItem",
      "updateItem",
      "loadFilteredData",
    ]),
  },
};
</script>

<style scoped lang="scss">
.app {
  background-image: url("@/assets/L1.png");
  background-size: cover;
  background-position: center;
}
.search-container {
  position: relative;
  margin-top: 20px;
  color: #ccc;
  font-size: 24px;
  left: 200px;
}

.dropdown {
  position: absolute;
  top: 100%;
  left: 0;
  width: 100%;
  background-color: #fff;
  border: 1px solid #ddd;
  max-height: 150px;
  overflow-y: auto;
  box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
  z-index: 1;
}

.dropdown div {
  padding: 10px;
  cursor: pointer;
}

.dropdown div:hover {
  background-color: #f0f0f0;
}
table {
  width: 70%;
  border-collapse: collapse;
  margin-top: 150px;
  margin-left: 40px;
  margin-bottom: 700px;
}

th,
td {
  border: 2px solid #695858;
  padding: 8px;
  text-align: left;
  background-color: #dbd9d9;
}

th {
  background-color: #f2f2f2;
}

button {
  background-color: #6adc35;
  color: #fff;
  border: none;
  padding: 5px 10px;
  cursor: pointer;
  border-radius: 4px;
}

button:hover {
  background-color: #36c823;
}
.student-form {
  border: 1px solid #000000;
  border-radius: 10px;
  padding: 15px;
  margin: 15px;
  width: 50%;
  margin-left: 140px;
  background-color: #d2cdcd;
  margin-top: 100px;
}

.student-form div {
  margin-bottom: 10px;
  display: flex;
  flex-direction: line;
  margin: 10px;
}

.student-form label {
  margin-bottom: 3px;
}

.student-form input {
  width: 100%;
  padding: 5px;
  box-sizing: border-box;
  border: 1px solid #ccc;
  border-radius: 50px;
  margin-left: 5px;
}

.student-form button {
  background-color: #4caf50;
  color: white;
  padding: 10px 15px;
  border: none;
  border-radius: 50px;
  cursor: pointer;
}

.student-form button:hover {
  background-color: #45a049;
}
.container {
  display: flex;
}

.left-container {
  flex: 1;
  padding-right: 10px;
}

.right-container {
  flex: 1;
  padding-right: 0px;
}
</style>
